package com.hfkj.service.discount.impl;

import com.hfkj.dao.CouponDiscountPackageDetailsMapper;
import com.hfkj.dao.CouponDiscountPackageMapper;
import com.hfkj.dao.CouponDiscountPackageRecordMapper;
import com.hfkj.entity.*;
import com.hfkj.service.discount.CouponDiscountPackageService;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("couponDiscountPackageService")
public class CouponDiscountPackageServiceImpl implements CouponDiscountPackageService {

    @Resource
    private CouponDiscountPackageMapper couponDiscountPackageMapper;

    @Resource
    private CouponDiscountPackageRecordMapper couponDiscountPackageRecordMapper;

    @Resource
    private CouponDiscountPackageDetailsMapper couponDiscountPackageDetailsMapper;

    @Override
    public void create(CouponDiscountPackage discountPackage) {
        couponDiscountPackageMapper.insert(discountPackage);
    }

    @Override
    public void update(CouponDiscountPackage discountPackage) {
        couponDiscountPackageMapper.updateByPrimaryKeySelective(discountPackage);
    }

    @Override
    public void delete(Long id, Boolean fullDelete) {

        if (fullDelete) {
            couponDiscountPackageMapper.deleteByPrimaryKey(id);
        } else {
            CouponDiscountPackage discountPackage = queryDetail(id);
            discountPackage.setStatus(0);
            discountPackage.setUpdatedTime(new Date());
            update(discountPackage);
        }
    }

    @Override
    public CouponDiscountPackage queryDetail(Long id) {
        return null;
    }

    @Override
    public CouponDiscountPackage queryDetailByMap(Map<String, Object> map) {
        return null;
    }

    @Override
    public List<CouponDiscountPackage> getList(Map<String, Object> map) {

        CouponDiscountPackageExample example = new CouponDiscountPackageExample();
        CouponDiscountPackageExample.Criteria criteria = example.createCriteria();

        if (StringUtils.isNotBlank(MapUtils.getString(map, "title"))) {
            criteria.andTitleLike("%"+MapUtils.getString(map, "title")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "key"))) {
            criteria.andKeyEqualTo(MapUtils.getString(map, "key"));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        } else {
            criteria.andStatusNotEqualTo(0);
        }

        return couponDiscountPackageMapper.selectByExample(example);
    }

    @Override
    public List<CouponDiscountPackageRecord> getListRecordByMap(Map<String, Object> map) {

        CouponDiscountPackageRecordExample example = new CouponDiscountPackageRecordExample();
        CouponDiscountPackageRecordExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getInteger(map, "discountPackageId") != null) {
            criteria.andDiscountPackageIdEqualTo(MapUtils.getInteger(map, "discountPackageId"));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        } else {
            criteria.andStatusNotEqualTo(0);
        }

        return couponDiscountPackageRecordMapper.selectByExample(example);
    }

    @Override
    public void createDetail(CouponDiscountPackageDetails discountPackageDetails) {
        couponDiscountPackageDetailsMapper.insert(discountPackageDetails);
    }

    @Override
    public void deleteDetail(Long id) {
        CouponDiscountPackageDetails discountPackageDetails = new CouponDiscountPackageDetails();
    }
}
